#pragma once

#include "standardfile_.h"
//
// standardgetfile is a base class to interface to CustomGetFile
//
// Note for CodeWarriors: if your compiler complains that it can not
// use a struct as a base class for standardgetfile you probably are using
// a precompiled header file generated with the C compiler with this C++
// code. You should recompile them with the C++ compiler, and all should
// be fine.
//
class standardgetfile : public standardfile
{
	public:
		standardgetfile( OSType thetype, short dlogID = sfGetDialogID);

		standardgetfile( OSType *thetypes = 0L, long numtypes = -1,
					short dlogID = sfGetDialogID);

		~standardgetfile();

		void changeTypes( OSType *thetypes, long numtypes);

		Boolean doIt();
		//
		// Functions to read the list of types accepted by this application,
		// as read from the 'typs' resource #128. Present for use by subclasses.
		//
		const OSType *GetTheTypes() const;
		short GetNumTypes() const;

	protected:

		OSType		*theTypes;
		long		numTypes;

	private:

		void setTypes( OSType *thetypes, long numtypes);
};

inline const OSType *standardgetfile::GetTheTypes() const
{
	return (OSType * const)theTypes;
}

inline short standardgetfile::GetNumTypes() const
{
	return numTypes;
}
